/*
 *   Tool for flood-filling an existing object.
 */

#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define FALSE 0
#define TRUE 1
#define DIM 20             /* Image is DIMxDIM (was 10). */
#define N 100              /* Max number of units allowed in net */

/*  X stuff */

Display *disptr;
GC       gc;

/*  Object specification */

char Objfname[80];
Pixmap Objpmap;
XImage *Objimage, *Newimage;
int Width, Height, x_hot, y_hot;

main(argc,argv)
     int argc;
     char *argv[];
{
  int ing;                  /* Needed for command line parsing */
  extern char *optarg;      /* Needed for command line parsing */

  int *pointertopmap;
  float f;
  char inc, OutputObjfname[80];

  int bitmap_size;
  int status, x,y, i,j;

  Objfname[0] = '*';

  disptr = XOpenDisplay(NULL);
  gc = DefaultGC(disptr, 0);

  /* Read in options */

  while ((ing = getopt(argc,argv,"o:")) != EOF)
    switch (ing)
      {
      case 'o': strcpy(Objfname, optarg);    break;
      }

  /* Read in the object. */

  if (Objfname[0] == '*')
    {
      printf (">> Error:  No object specified.  Use -o <Object>.\n");
      exit(1);
    }
  else
    {
      status = XReadBitmapFile(disptr,XDefaultRootWindow(disptr),
			       Objfname, &Width, &Height, &Objpmap, 
			       &x_hot, &y_hot);
      if (status != BitmapSuccess)
	{
	  printf (">> Error:  Could not read object file.\n");
	  exit(1);
	}
    }
	
  /*  Fill the object. */

  Objimage = XGetImage(disptr,Objpmap, 0,0, Width,Height, 
		       1, XYPixmap);
  Newimage = XSubImage(Objimage, 0,0, Width, Height);

  Flood(0,0);

  XSetFunction(disptr,gc,GXorInverted);
  XPutImage(disptr,Objpmap,gc,Newimage, 0,0, 0,0, Width,Height);


  /*  Write it out.  */

  sprintf (OutputObjfname, "Filled%s", Objfname);
  status = XWriteBitmapFile(disptr, OutputObjfname, Objpmap, Width,Height,
			    x_hot,y_hot);
  if (status != BitmapSuccess)
    {
      printf (">> Error:  Could not write filled object file.\n");
      exit(1);
    }
}

/*
 *  Paint a spot and continue. 
 */
Flood(i,j)
     int i,j;
{
  if ((i>=0) &&                          /* In range, and not boundary */
      (i<=Width-1) && 
      (j>=0) && 
      (j<=Height-1) &&
      (XGetPixel(Objimage, i,j) == 0) &&
      (XGetPixel(Newimage, i,j) == 0))
    {
      XPutPixel(Newimage, i,j, 1);
      Flood(i-1,j);
      Flood(i,j-1);
      Flood(i+1,j);
      Flood(i,j+1);
    }
}
